# MPI_Comm_spawn_multiple

short description

## Synopsis

    int MPI_Comm_spawn_multiple(int count, char *array_of_commands[],
                              char* *array_of_argv[], int array_of_maxprocs[],
                              MPI_Info array_of_info[], int root, MPI_Comm comm,
                              MPI_Comm *intercomm, int array_of_errcodes[])

## Input Parameters

count
  number of commands (positive integer, significant to MPI only at root
array_of_commands
  programs to be executed (array of strings, significant only at root)
array_of_argv
  arguments for commands (array of array of strings, significant only at root)
array_of_maxprocs
  maximum number of processes to start for each command (array of integer, significant only at root)
array_of_info
  info objects telling the runtime system where and how to start processes (array of handles, significant only at root)
root
  rank of process in which previous arguments are examined (integer)
comm
  intracommunicator containing group of spawning processes (handle)

## Output Parameters

intercomm
  intercommunicator between original group and newly spawned group (handle)
array_of_errcodes
  one error code per process (array of integer)

## Notes for Fortran

All MPI routines in Fortran (except for `MPI_WTIME` and `MPI_WTICK`) have an additional argument `ierr` at the end of the argument list. `ierr` is an integer and has the same meaning as the return value of the routine in C. In Fortran, MPI routines are subroutines, and are invoked with the `call` statement.

All MPI objects (e.g., `MPI_Datatype`, `MPI_Comm`) are of type `INTEGER` in Fortran.

## Errors

All MPI routines (except `MPI_Wtime` and `MPI_Wtick`) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with `MPI_Comm_set_errhandler` (for communicators), `MPI_File_set_errhandler` (for files), and `MPI_Win_set_errhandler` (for RMA windows). The MPI-1 routine `MPI_Errhandler_set` may be used but its use is deprecated. The predefined error handler `MPI_ERRORS_RETURN` may be used to cause error values to be returned. Note that MPI does not guarentee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.

MPI_SUCCESS
  No error; MPI routine completed successfully.

MPI_ERR_COMM
  Invalid communicator. A common error is to use a null communicator in a call (not even allowed in `MPI_Comm_rank`).

MPI_ERR_ARG
  Invalid argument. Some argument is invalid and is not identified by a specific error class (e.g., `MPI_ERR_RANK`).

MPI_ERR_INFO
  Invalid Info

MPI_ERR_SPAWN

Location:comm_spawn_multiple.c